	.ORIG	x4100
;; Activation record for cmp16
;;
;;  offsets to R5 during call
;;  -2 -- SAVED R2 (last  local)    -- R6 here during call
;;  -1 -- SAVED R1
;;   0 -- SAVED R0 (first local)    -- R5 here during call
;;   1 -- dynamic link
;;   2 -- return PC
;;   3 -- return value              -- R6 here on exit
;;   4 -- ARG 1         (A)         -- R6 here on entry
;;   5 -- ARG 2         (B)
;;
;;   If A<B, return -1
;;   If A=B, return  0
;;   If A>B, return  1
	
;; CREATE THE ACTIVATION RECORD
cmp16	STR     R7,R6,#-2      ;; Store caller PC
        STR     R5,R6,#-3      ;; Store caller dynamic link
        ADD     R5,R6,#-4      ;; Set R5 to first local
        ADD     R6,R5,#-2      ;; Set R6 to last local

;; SAVE REGS
        STR     R0,R5,#0
        STR     R1,R5,#-1
        STR     R2,R5,#-2

;; DO THE WORK
        AND     R2,R2,#0       ;; R2 <- 0
        LDR     R1,R5,#5       ;; R1 <- B
        BRn	Bneg
	BRz	Bzero
;; 0 < B
	LDR	R0,R5,#4       ;; load A into R0
	BRnz	retm1          ;; A <= 0 < B, return -1
;; 0 < A && 0 < B
	NOT	R1,R1
	ADD	R1,R1,#1       ;; R1 <- A-B
	BRnzp	atestem

Bzero
;; B == 0
	LDR	R0,R5,#4       ;; R0 <- A = A-B
	BRnzp	testem

Bneg
;; B < 0
	LDR	R0,r5,#4       ;; R0 <- A
	BRzp	retp1          ;; A >= 0 > B, return 1
;; A < 0 && B < 0
	NOT	R1,R1
	ADD	R0,R0,#1       ;; This makes it work even if B=x8000
atestem	ADD	R0,R0,R1       ;; R0 <- A-B
;; NZP set for result A-B
testem	BRn	retm1
	Brz	retnow

retp1	ADD	R2,R2,#1
	BRnzp	retnow
retm1	ADD	R2,R2,#-1

retnow
;; SAVE RETURN VALUE
	STR	R2,R5,#3       ;; Save return value

;; RESTORE REGS
        LDR     R0,R5,#0
        LDR     R1,R5,#-1
        LDR     R2,R5,#-2

;; RETURN AND DELETE ACTIVATION RECORD
        LDR     R7,R5,#2
        ADD     R6,R5,#3
        LDR     R5,R5,#1
        RET

	.END

