	.ORIG	x4200
;; Activation record for lt16
;;
;;  offsets to R5 during call
;;  -2 -- SAVED R2 (last  local)    -- R6 here during call
;;  -1 -- SAVED R1
;;   0 -- SAVED R0 (first local)    -- R5 here during call
;;   1 -- dynamic link
;;   2 -- return PC
;;   3 -- return value  (A<B)       -- R6 here on exit
;;   4 -- ARG 1         (A)         -- R6 here on entry
;;   5 -- ARG 2         (B)
;;

;; CREATE THE ACTIVATION RECORD
lt16	STR     R7,R6,#-2      ;; Store caller PC
        STR     R5,R6,#-3      ;; Store caller dynamic link
        ADD     R5,R6,#-4      ;; Set R5 to first local
        ADD     R6,R5,#-2      ;; Set R6 to last local

;; SAVE REGS
        STR     R0,R5,#0
        STR     R1,R5,#-1
        STR     R2,R5,#-2

;; DO THE WORK
        LDR     R0,R5,#4       ;; R0 <- A
        LDR     R1,R5,#5       ;; R1 <- B
	LD      R2,acmp16

;; Push A and B on the call stack
        STR     R1,R6,#-1
        STR     R0,R6,#-2
        ADD     R6,R6,#-2

;; Call
        JSRR    R2

        AND     R0,R0,#0       ;; R0 <- 0
        LDR     R1,R6,#0       ;; R1 <- cmp16(A,B)
        BRzp    Leave
        ADD     R0,R0,#1

Leave
;; POP RETURN VALUE AND ARGS
        ADD     R6,R6,#3

;; SAVE RETURN VALUE
	STR	R0,R5,#3       ;; Save return value

;; RESTORE REGS
        LDR     R0,R5,#0
        LDR     R1,R5,#-1
        LDR     R2,R5,#-2

;; RETURN AND DELETE ACTIVATION RECORD
        LDR     R7,R5,#2
        ADD     R6,R5,#3
        LDR     R5,R5,#1
        RET

acmp16	.FILL	x4100
	.END

